
uniform sampler2D ColorTexture;

uniform float EffectLevel;
uniform float ITime;
uniform float Scale;
uniform float Typ;

float rand(vec2 co) {
    return fract(sin(dot(co.xy ,vec2(12.9898,78.233))) * 43758.5453);
}

float terrain(float x) {
    //Used Shadershop
    //You actually should look after sigma.
    float v = 0.; 
    x *= 3.;  //3
    #define l 2. //13
    for (float n = 0.; n < l; n++) {
        v += ((sin((x*sin(n/2.142))+(n/1.41)))/l)*3.;
    }
    return pow(v,3.);
}

vec3 draw(vec2 uv) {
    return vec3(texture(ColorTexture,vec2(uv.x,1.-uv.y)).rgb);
}
/////////////
float random (in vec2 st) {
    return fract(sin(dot(st.xy,
                         vec2(12.9898,78.233)))*
        43758.5453123);
}

float noise (in vec2 st) {
    vec2 i = floor(st);
    vec2 f = fract(st);

    // Four corners in 2D of a tile
    float a = random(i);
    float b = random(i + vec2(1.0, 0.0));
    float c = random(i + vec2(0.0, 1.0));
    float d = random(i + vec2(1.0, 1.0));

    vec2 u = f * f * (3.0 - 2.0 * f);

    return mix(a, b, u.x) +
            (c - a)* u.y * (1.0 - u.x) +
            (d - b) * u.x * u.y;
}

#define OCTAVES 1
float fbm (in vec2 st) {
    // Initial values
    float value = 0.0;
    float amplitude = .125;
    float frequency = 0.;
    //
    // Loop of octaves
    for (int i = 0; i < OCTAVES; i++) {
        value += amplitude * noise(st);
        st *= 2.;
        amplitude *= .5;
    }
    return value*0.5+0.5;
}



void shader(){
	//b3d_Texcoord0;
	vec2 texcoords=(b3d_ClipPosition.st/b3d_ClipPosition.w)*0.5+0.5;
	vec4 color=texture2D( ColorTexture,texcoords ).rgba;
	//b3d_FragColor = color;
	
	////////////   FLAT  /////////////
	if(Typ==0){
		
		b3d_FragColor=texture(ColorTexture, texcoords); //color;	//mipmap not working
	}
	
	////////////   SINE  /////////////
	if(Typ==1){
		texcoords.x += sin(texcoords.y*8+(ITime*3))/Scale;//25.0;
		texcoords.y += sin(texcoords.x*4+(ITime*3))/Scale/2;  //4
		
		//texcoords.x += rand(texcoords)*0.01;
		
		b3d_FragColor = texture(ColorTexture, texcoords);
	}
	
	////////////   LENS  /////////////
	if(Typ==2) {
	
		// Normalized pixel coordinates (from 0 to 1)
	    vec2 uv = (b3d_ClipPosition.st/b3d_ClipPosition.w)*0.5+0.5; //fragCoord/iResolution.xy;
	    
	    float p = 1.1*fbm(1.*uv+ITime);
	    float q = 11.*fbm(uv * 3.*p + ITime*3);
	    float r = fbm(uv * 5.*q);
	    
		uv += (r * p - q / 8.0)+0.43;//*0.6; //uv-r*p-q/8.0;
	
	    // Time varying pixel color
		vec4 col = texture(ColorTexture, uv);
	    // Output to screen
	    b3d_FragColor = vec4(col);
	}
}